/**
 * 1Gb API
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import * as querystring from "querystring";
import * as url from "url";

import * as isomorphicFetch from "isomorphic-fetch";
import * as assign from "core-js/library/fn/object/assign";

interface Dictionary<T> { [index: string]: T; }
export interface FetchAPI { (url: string, init?: any): Promise<any>; }

const BASE_PATH = "https://www.1gb.ru/api";

export interface FetchArgs {
    url: string;
    options: any; 
}

export class BaseAPI {
    basePath: string;
    fetch: FetchAPI;

    constructor(fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) {
        this.basePath = basePath;
        this.fetch = fetch;
    }
}

export interface InlineResponse200 {
    /**
     * Планируемое количество дней до наступления негативного баланса
     */
    "negativeBalanceDays": number;
    /**
     * Планируемое количество дней до наступления негативного баланса по аккаунту лицензий
     */
    "negativeBalanceDaysLic": number;
    /**
     * 
     */
    "lastMonthDebtSum": number;
    /**
     * 
     */
    "lastMonthDebtSum2": number;
    /**
     * Дата блокировки аккаунта
     */
    "blockDate": string;
}

export interface InlineResponse2001 {
    /**
     * Идентификатор аккаунта
     */
    "id": number;
    /**
     * Описание аккаунта
     */
    "description": string;
    /**
     * Идентификатор тарифной группы
     */
    "billingGroupId": number;
    /**
     * Аккаунт заблокирован, если true
     */
    "blocked": string;
    /**
     * Дата блокировки
     */
    "blockedDate"?: string;
    /**
     * Причина блокировки
     */
    "blockedReason"?: string;
    /**
     * Ограничение суммы на работу в аванс
     */
    "creditLimit": number;
    /**
     * Идентификатор тарифа
     */
    "planId": number;
    /**
     * Идентификатор тарифа (периода)
     */
    "periodId": number;
    /**
     * Тип договора
     */
    "contractType": number;
    /**
     * 
     */
    "clientId": number;
    /**
     * Логин клиента
     */
    "clientLogin": string;
    /**
     * Номер договора
     */
    "contractId": string;
    /**
     * Имя клиента на русском
     */
    "nameRus": string;
    /**
     * Имя клиента на английском
     */
    "nameEng": string;
    /**
     * E-mail клиент
     */
    "email": string;
    /**
     * Количество созданных сайтов
     */
    "statSites": number;
    /**
     * Используемое дисковое пространство
     */
    "statSizeMb": number;
    /**
     * Количество созданных почтовых ящиков
     */
    "statEmails": number;
    /**
     * Количество баз данных MySQL
     */
    "statMysqls": number;
    /**
     * 
     */
    "statTech": number;
    /**
     * 
     */
    "statNicd": number;
    /**
     * 
     */
    "statAccessDynamic": number;
    /**
     * 
     */
    "statAccessStatic": number;
    /**
     * 
     */
    "statAccessTraffic": number;
    /**
     * 
     */
    "statPaidTotal": number;
    /**
     * Размер дисков VDS
     */
    "statVdsSize": number;
    /**
     * Название тарифного плана
     */
    "planName": string;
    /**
     * Количество месяцев в оплаченном периоде
     */
    "periodMonths": number;
    /**
     * Стоимость оплаченного периода
     */
    "periodPrice": number;
    /**
     * 
     */
    "expires": string;
    /**
     * Префикс для вывода текущей валюты хостинга (например, в строке '$100' префиксом является '$')
     */
    "externalCurrencySpelledPrefix": string;
    /**
     * Суффикс для вывода текущей валюты хостинга (например, в строке '100 руб.' суффиксом является ' руб.'
     */
    "externalCurrencySpelledSuffix": string;
}

export interface InlineResponse20010 {
    /**
     * Идентификатор записи
     */
    "id": number;
    /**
     * Дата и время создания записи
     */
    "datetime": string;
    /**
     * Тело сообщения (с HTML-тэгами)
     */
    "description": string;
    /**
     * Тело сообщения (без тэгов)
     */
    "descriptionPlain": string;
}

export interface InlineResponse20011 {
    /**
     * IP-адрес
     */
    "ip": string;
    /**
     * идентификатор VDS
     */
    "vdsId": number;
}

export interface InlineResponse20012 {
    /**
     * идентификатор VDS
     */
    "id": number;
    /**
     * VDS удалён если true
     */
    "deleted": boolean;
    /**
     * VDS работает нормально если true
     */
    "online": boolean;
    /**
     * VDS остановлен если true
     */
    "stopped": boolean;
    /**
     * изначальный пароль администратора или root
     */
    "pwd": string;
    /**
     * шаблон, на основе которого был создан VDS
     */
    "template": string;
    /**
     * полное описание типа VDS
     */
    "typeFull": string;
    /**
     * MAC-адрес VDS
     */
    "physicalMac": string;
    /**
     * тип VDS
     */
    "type": string;
}

export interface InlineResponse20013 {
    /**
     * Тип VDS, для которого применим шаблон. Принимает значения 'hv' и 'vz'
     */
    "type": string;
    /**
     * Имя шаблона
     */
    "template": string;
    /**
     * Популярность
     */
    "popularity": number;
    /**
     * Актуальность шаблона. 1 = шаблон актуален
     */
    "actualTemplate": number;
}

export interface InlineResponse20014 {
    /**
     * 
     */
    "id": number;
    /**
     * 
     */
    "status": string;
    /**
     * 
     */
    "unmovable": string;
    /**
     * Включен (активен), если true.
     */
    "online": string;
    /**
     * Удален, если true. Данные могут сохраняться.
     */
    "deleted": string;
    /**
     * Удален, если true. Данные могут сохраняться.
     */
    "deletedAuto": string;
    /**
     * 
     */
    "deletedDump": string;
    /**
     * 
     */
    "userId": string;
    /**
     * 
     */
    "ftpId": string;
    /**
     * 
     */
    "dnsId": string;
    /**
     * 
     */
    "iisId": string;
    /**
     * 
     */
    "iisBinding": string;
    /**
     * 
     */
    "iisPath": string;
    /**
     * Уникальное строковое имя сайта (ID).
     */
    "iisComments": string;
    /**
     * 
     */
    "memo": string;
    /**
     * Дата создания.
     */
    "dateReg": string;
    /**
     * Тип веб-сервера.
     */
    "server": string;
    /**
     * 
     */
    "serverBak": string;
    /**
     * 
     */
    "serverAux": string;
    /**
     * Тип сервера недавно изменялся, если true.
     */
    "serverTransition": string;
    /**
     * 
     */
    "serverTransitionDtc": string;
    /**
     * 
     */
    "blockTransfer": string;
    /**
     * 
     */
    "serverChangedTime": string;
    /**
     * Размер веб-сайта - объем (Кб).
     */
    "sizeAmount": string;
    /**
     * Размер веб-сайта - кол-во файлов.
     */
    "sizeFileCount": string;
    /**
     * 
     */
    "sizeFileCountLimit": string;
    /**
     * Размер веб-сайта - дата замера.
     */
    "sizeDate": string;
    /**
     * 
     */
    "sizePriorityScan": string;
    /**
     * 
     */
    "copyLogs": string;
    /**
     * 
     */
    "contentComments": string;
    /**
     * 
     */
    "contentCommentsVerbose": string;
    /**
     * 
     */
    "metaSaveCount": string;
    /**
     * 
     */
    "baseFolder": string;
    /**
     * 
     */
    "virtualhostConf": string;
    /**
     * 
     */
    "virtualhostServer": string;
    /**
     * 
     */
    "virtualhostServerConf": string;
    /**
     * 
     */
    "liveDayCount": string;
    /**
     * 
     */
    "scanDate": string;
    /**
     * 
     */
    "globalTransferCount": string;
    /**
     * 
     */
    "netLimitFile": string;
    /**
     * 
     */
    "netLimitDenyFromIp": string;
    /**
     * 
     */
    "netLimitDenyFromAgent": string;
    /**
     * 
     */
    "apachePhpPooled": string;
    /**
     * 
     */
    "apachePhpPooledExt": string;
    /**
     * 
     */
    "apachePhpPooledExtAuto": string;
    /**
     * 
     */
    "apachePhpPool1Only": string;
    /**
     * 
     */
    "apachePhpPool5Only": string;
    /**
     * 
     */
    "apacheSsi": string;
    /**
     * 
     */
    "bypassSecurity": string;
    /**
     * 
     */
    "flagGenericExec": string;
    /**
     * 
     */
    "flagNoWww": string;
    /**
     * 
     */
    "baseFolderSuffix": string;
    /**
     * 
     */
    "feedbackSpeed": string;
    /**
     * 
     */
    "feedbackSpeedDtc": string;
    /**
     * 
     */
    "feedbackSpeedFeedback": string;
    /**
     * 
     */
    "unixPathOnWindows": string;
    /**
     * Ограничение по IP адресам - FTP доступ.
     */
    "ftpIpfilter": string;
    /**
     * Ограничение по IP адресам - SSH доступ.
     */
    "sshIpfilter": string;
    /**
     * 
     */
    "l3dAuto": string;
    /**
     * 
     */
    "awstatsPrimaryDomain": string;
    /**
     * 
     */
    "sharepointMode": string;
    /**
     * 
     */
    "sharepointModePending": string;
    /**
     * 
     */
    "apacheGenericPoolPort": string;
    /**
     * 
     */
    "mongrelEnvironment": string;
    /**
     * 
     */
    "flagFree": string;
    /**
     * 
     */
    "rtmScanDate": string;
    /**
     * 
     */
    "analyzeAnalog": string;
    /**
     * Включен режим предоставления детализации процессорной нагрузки.
     */
    "cpuDetailsEnabled": string;
    /**
     * 
     */
    "contentModeratedStatus": string;
    /**
     * 
     */
    "contentModeratedDate": string;
    /**
     * 
     */
    "httpFrontendIp": string;
    /**
     * 
     */
    "httpFrontendIpTransition": string;
    /**
     * Дата последнего превышения процессорной нагрузки.
     */
    "cpuLimitExceededDate": string;
    /**
     * Признак сайта-конструктора.
     */
    "aufsTemplate": string;
    /**
     * 
     */
    "optionsAutolimit": string;
    /**
     * Версия ASP.NET, если отлична от 2.0.
     */
    "iisCreationCommands": string;
    /**
     * 
     */
    "iisCreationCommandsUnix": string;
    /**
     * 
     */
    "thumbDate": string;
    /**
     * 
     */
    "thumbFailed": string;
    /**
     * 
     */
    "backupStatDate": string;
    /**
     * Дата пофайловой резервной копии.
     */
    "backupDate": string;
    /**
     * 
     */
    "detectedPackages": string;
    /**
     * 
     */
    "statSitePower": string;
    /**
     * 
     */
    "smtpFrom": string;
    /**
     * 
     */
    "superBackupDate": string;
    /**
     * 
     */
    "backupDeltaStatDate": string;
    /**
     * Дата архивной резервной копии.
     */
    "backupDeltaDate": string;
    /**
     * Содержимое архивной резервной копии.
     */
    "backupDeltaDesc": string;
    /**
     * 
     */
    "altDocrootServer": string;
    /**
     * 
     */
    "altDocrootPath": string;
    /**
     * 
     */
    "altDocrootStatus": string;
    /**
     * 
     */
    "altDocrootStatusCnt": string;
    /**
     * 
     */
    "altDocrootStatusDate": string;
    /**
     * Последнее изменение привязок доменов для сайта.
     */
    "bindDtc": string;
    /**
     * 
     */
    "backupSpecialMode": string;
    /**
     * 
     */
    "sizeCheckProblem": string;
    /**
     * 
     */
    "wpbDomain": string;
    /**
     * Для сайта включен конструктор Parallels WPB.
     */
    "wpbUuid": string;
    /**
     * 
     */
    "wpbStatus": string;
    /**
     * 
     */
    "adminProtection": string;
    /**
     * 
     */
    "sizeComments": string;
    /**
     * 
     */
    "altDocrootSsdReq": string;
    /**
     * 
     */
    "mailLimit": string;
    /**
     * 
     */
    "mailAccept": string;
    /**
     * 
     */
    "mailDrop": string;
    /**
     * FTP/SSH/SCP/SFTP логин.
     */
    "ftpName": string;
    /**
     * FTP/SSH/SCP/SFTP пароль.
     */
    "ftpPwd": string;
}

export interface InlineResponse2002 {
    /**
     * идентификатор аккаунта
     */
    "id": number;
    /**
     * логин
     */
    "name": string;
    /**
     * идентификатор сервера. Если равен или больше 10000, то это Postgres. Иначе MySQL
     */
    "server": string;
    /**
     * пароль
     */
    "pwd": string;
    /**
     * суффикс домена сервера
     */
    "urlSuffix": string;
}

export interface InlineResponse2003 {
    /**
     * идентификатор домена
     */
    "id": number;
    /**
     * идентификатор связанной записи IIS
     */
    "iisId": number;
    /**
     * домен работает, если true
     */
    "online": boolean;
    /**
     * полное имя домена
     */
    "fullDomainName": string;
    /**
     * 
     */
    "fullDomainNameLocal": string;
    /**
     * 
     */
    "addr1": string;
    /**
     * зона домена
     */
    "zone": string;
}

export interface InlineResponse2004 {
    /**
     * Дата последнего обновления домена
     */
    "dateUpdated": string;
    /**
     * Дата создания записи
     */
    "recordCreated": string;
    /**
     * 
     */
    "subjectContract": string;
    /**
     * 
     */
    "endDate": string;
    /**
     * Дата, до которой оплачен домен
     */
    "payedTill": string;
    /**
     * 
     */
    "objectState": string;
    /**
     * Имя домена
     */
    "domainAddr": string;
    /**
     * Сервера имён домена
     */
    "nservers": string;
    /**
     * Количество дней до окончания срока действия домена
     */
    "expiresCountdown": number;
}

export interface InlineResponse2005 {
    /**
     * идентификатор псевдонима
     */
    "id": number;
    /**
     * почтовый ящик псевдонима
     */
    "mail": string;
    /**
     * имя псевдонима
     */
    "alias": string;
}

export interface InlineResponse2006 {
    /**
     * идентификатор ящика
     */
    "id": number;
    /**
     * 
     */
    "status": number;
    /**
     * ящик работает, если true
     */
    "online": boolean;
    /**
     * полный адрес ящика
     */
    "mail": string;
    /**
     * имя пользователя для входа в Mercury
     */
    "mercuryUser": string;
    /**
     * пароль для входа в Mercury
     */
    "mercuryPwd": string;
    /**
     * текущий размер ящика
     */
    "sizeAmount": number;
    /**
     * количество файлов, занятых ящиком
     */
    "sizeFileCount": number;
    /**
     * 
     */
    "archivedCount": number;
    /**
     * адрес сервера для доступа к ящику по POP3
     */
    "serverPop3": string;
    /**
     * адрес сервера для доступа к ящику по SMTP
     */
    "serverSmtp": string;
    /**
     * адрес сервера Webmail для входа в ящик через браузер
     */
    "serverWebmail": string;
    /**
     * адрес сервера для доступа к ящику по IMAP
     */
    "serverImap": string;
    /**
     * 
     */
    "wm1": string;
    /**
     * 
     */
    "wm2": string;
}

export interface InlineResponse2007 {
    /**
     * идентификатор аккаунта
     */
    "id": number;
    /**
     * логин
     */
    "name": string;
    /**
     * пароль
     */
    "pwd": string;
}

export interface InlineResponse2008 {
    /**
     * идентификатор сайта
     */
    "id": number;
    /**
     * сайт работает нормально если true
     */
    "online": boolean;
    /**
     * идентификатор связанного аккаунта FTP
     */
    "ftpId": number;
    /**
     * идентификатор связанной записи DNS
     */
    "dnsId": number;
    /**
     * размер занятого места
     */
    "sizeAmount": number;
    /**
     * количество файлов
     */
    "sizeFileCount": number;
    /**
     * ограничение на количество файлов
     */
    "sizeFileCountLimit": number;
}

export interface InlineResponse2009 {
    /**
     * идентификатор аккаунта
     */
    "id": number;
    /**
     * имя базы данных
     */
    "db": string;
    /**
     * адрес сервера
     */
    "server": string;
    /**
     * логин
     */
    "name": string;
    /**
     * пароль
     */
    "pwd": string;
}

export interface _ {
    /**
     * Ограничение на количество почтовых ящиков. '-' означает отсутствие лимита.
     */
    "mail": string;
    /**
     * Ограничение на количество сайтов. '-' означает отсутствие лимита.
     */
    "website": string;
    /**
     * MySQL разрешен, если true.
     */
    "mysql": boolean;
    /**
     * Ограничение на размер дискового пространства. '-' означает отсутствие лимита.
     */
    "size": string;
    /**
     * MSSQL разрешен, если true.
     */
    "mssql": boolean;
    /**
     * CGI и PHP скрипты разрешены, если true.
     */
    "dynamicContent": boolean;
    /**
     * Функция exec() в PHP разрешена, если true.
     */
    "phpExec": boolean;
    /**
     * Ограничение на количество дополнительных FTP логинов. '-' означает отсутствие лимита.
     */
    "ftp2": string;
}



/**
 * DefaultApi - fetch parameter creator
 */
export const DefaultApiFetchParamCreactor = {
    /** 
     * Аккаунт: баланс
     * Возвращает текущий баланс аккаунта
     * @param token_ Ключ доступа, полученный при авторизации
     */
    balanceGet(params: {  token_: string; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling balanceGet");
        }
        const baseUrl = `/balance`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Аккаунт: баланс аккаунта лицензий
     * Возвращает текущий баланс аккаунта лицензий
     * @param token_ Ключ доступа, полученный при авторизации
     */
    balanceLicGet(params: {  token_: string; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling balanceLicGet");
        }
        const baseUrl = `/balance.lic`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Информация по дебету аккаунта
     * Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения
     * @param token_ Ключ доступа, полученный при авторизации
     */
    billingDebtGet(params: {  token_: string; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling billingDebtGet");
        }
        const baseUrl = `/billing/debt`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Информация об аккаунте
     * Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.
     * @param token_ Ключ доступа, полученный при авторизации
     */
    billingInfoGet(params: {  token_: string; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling billingInfoGet");
        }
        const baseUrl = `/billing/info`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Получить ограничения аккаунта
     * @param token_ Ключ доступа, полученный при авторизации
     */
    billingLimitsGet(params: {  token_: string; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling billingLimitsGet");
        }
        const baseUrl = `/billing/limits`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Информация по продлению доменов
     * @param token_ Ключ доступа, полученный при авторизации
     */
    dnsProlongListGet(params: {  token_: string; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling dnsProlongListGet");
        }
        const baseUrl = `/dns/prolong/list`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Создание почтового ящика
     * @param token_ Ключ доступа, полученный при авторизации
     * @param addEmail Адрес почтового ящика, который необходимо создать
     */
    emailAddGet(params: {  token_: string; addEmail: string; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling emailAddGet");
        }
        // verify required parameter "addEmail" is set
        if (params["addEmail"] == null) {
            throw new Error("Missing required parameter addEmail when calling emailAddGet");
        }
        const baseUrl = `/email/add`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
            "add_email": params.addEmail,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Удаление псевдонимов почтовых ящиков
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ Адрес почтового ящика, подлежащего удалению
     */
    emailAliasDeleteGet(params: {  token_: string; key_: string; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling emailAliasDeleteGet");
        }
        // verify required parameter "key_" is set
        if (params["key_"] == null) {
            throw new Error("Missing required parameter key_ when calling emailAliasDeleteGet");
        }
        const baseUrl = `/email/alias/delete`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
            "_key_": params.key_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Получить список псевдонимов почтовых ящиков
     * @param token_ Ключ доступа, полученный при авторизации
     */
    emailAliasListGet(params: {  token_: string; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling emailAliasListGet");
        }
        const baseUrl = `/email/alias/list`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Удаление почтового ящика
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ Адрес почтового ящика, подлежащего удалению
     */
    emailDeleteGet(params: {  token_: string; key_: string; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling emailDeleteGet");
        }
        // verify required parameter "key_" is set
        if (params["key_"] == null) {
            throw new Error("Missing required parameter key_ when calling emailDeleteGet");
        }
        const baseUrl = `/email/delete`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
            "_key_": params.key_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Получить список почтовых ящиков
     * @param token_ Ключ доступа, полученный при авторизации
     */
    emailListGet(params: {  token_: string; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling emailListGet");
        }
        const baseUrl = `/email/list`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Идентификатор последнего уведомления в аудите
     * @param token_ Ключ доступа, полученный при авторизации
     */
    updatesLastGet(params: {  token_: string; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling updatesLastGet");
        }
        const baseUrl = `/updates/last`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Список записей аудита
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID первой записи для показа или 0 для показа всех записей
     */
    updatesListGet(params: {  token_: string; key_: number; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling updatesListGet");
        }
        // verify required parameter "key_" is set
        if (params["key_"] == null) {
            throw new Error("Missing required parameter key_ when calling updatesListGet");
        }
        const baseUrl = `/updates/list`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
            "_key_": params.key_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Удаление сайта
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID сайта, полученный из /website/list
     */
    websiteDeleteGet(params: {  token_: string; key_: string; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling websiteDeleteGet");
        }
        // verify required parameter "key_" is set
        if (params["key_"] == null) {
            throw new Error("Missing required parameter key_ when calling websiteDeleteGet");
        }
        const baseUrl = `/website/delete`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
            "_key_": params.key_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Список сайтов аккаунта
     * @param token_ Ключ доступа, полученный при авторизации
     */
    websiteListGet(params: {  token_: string; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling websiteListGet");
        }
        const baseUrl = `/website/list`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
}

/**
 * DefaultApi - functional programming interface
 */
export const DefaultApiFp = {
    /** 
     * Аккаунт: баланс
     * Возвращает текущий баланс аккаунта
     * @param token_ Ключ доступа, полученный при авторизации
     */
    balanceGet(params: { token_: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<number> {
        const fetchArgs = DefaultApiFetchParamCreactor.balanceGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Аккаунт: баланс аккаунта лицензий
     * Возвращает текущий баланс аккаунта лицензий
     * @param token_ Ключ доступа, полученный при авторизации
     */
    balanceLicGet(params: { token_: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<number> {
        const fetchArgs = DefaultApiFetchParamCreactor.balanceLicGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Информация по дебету аккаунта
     * Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения
     * @param token_ Ключ доступа, полученный при авторизации
     */
    billingDebtGet(params: { token_: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<Array<InlineResponse200>> {
        const fetchArgs = DefaultApiFetchParamCreactor.billingDebtGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Информация об аккаунте
     * Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.
     * @param token_ Ключ доступа, полученный при авторизации
     */
    billingInfoGet(params: { token_: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<Array<InlineResponse2001>> {
        const fetchArgs = DefaultApiFetchParamCreactor.billingInfoGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Получить ограничения аккаунта
     * @param token_ Ключ доступа, полученный при авторизации
     */
    billingLimitsGet(params: { token_: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<_> {
        const fetchArgs = DefaultApiFetchParamCreactor.billingLimitsGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Информация по продлению доменов
     * @param token_ Ключ доступа, полученный при авторизации
     */
    dnsProlongListGet(params: { token_: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<Array<InlineResponse2004>> {
        const fetchArgs = DefaultApiFetchParamCreactor.dnsProlongListGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Создание почтового ящика
     * @param token_ Ключ доступа, полученный при авторизации
     * @param addEmail Адрес почтового ящика, который необходимо создать
     */
    emailAddGet(params: { token_: string; addEmail: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<string> {
        const fetchArgs = DefaultApiFetchParamCreactor.emailAddGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Удаление псевдонимов почтовых ящиков
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ Адрес почтового ящика, подлежащего удалению
     */
    emailAliasDeleteGet(params: { token_: string; key_: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<string> {
        const fetchArgs = DefaultApiFetchParamCreactor.emailAliasDeleteGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Получить список псевдонимов почтовых ящиков
     * @param token_ Ключ доступа, полученный при авторизации
     */
    emailAliasListGet(params: { token_: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<Array<InlineResponse2005>> {
        const fetchArgs = DefaultApiFetchParamCreactor.emailAliasListGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Удаление почтового ящика
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ Адрес почтового ящика, подлежащего удалению
     */
    emailDeleteGet(params: { token_: string; key_: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<string> {
        const fetchArgs = DefaultApiFetchParamCreactor.emailDeleteGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Получить список почтовых ящиков
     * @param token_ Ключ доступа, полученный при авторизации
     */
    emailListGet(params: { token_: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<Array<InlineResponse2006>> {
        const fetchArgs = DefaultApiFetchParamCreactor.emailListGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Идентификатор последнего уведомления в аудите
     * @param token_ Ключ доступа, полученный при авторизации
     */
    updatesLastGet(params: { token_: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<number> {
        const fetchArgs = DefaultApiFetchParamCreactor.updatesLastGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Список записей аудита
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID первой записи для показа или 0 для показа всех записей
     */
    updatesListGet(params: { token_: string; key_: number;  }): (fetch: FetchAPI, basePath?: string) => Promise<Array<InlineResponse20010>> {
        const fetchArgs = DefaultApiFetchParamCreactor.updatesListGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Удаление сайта
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID сайта, полученный из /website/list
     */
    websiteDeleteGet(params: { token_: string; key_: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<string> {
        const fetchArgs = DefaultApiFetchParamCreactor.websiteDeleteGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Список сайтов аккаунта
     * @param token_ Ключ доступа, полученный при авторизации
     */
    websiteListGet(params: { token_: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<Array<InlineResponse20014>> {
        const fetchArgs = DefaultApiFetchParamCreactor.websiteListGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
};

/**
 * DefaultApi - object-oriented interface
 */
export class DefaultApi extends BaseAPI {
    /** 
     * Аккаунт: баланс
     * Возвращает текущий баланс аккаунта
     * @param token_ Ключ доступа, полученный при авторизации
     */
    balanceGet(params: {  token_: string; }) {
        return DefaultApiFp.balanceGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Аккаунт: баланс аккаунта лицензий
     * Возвращает текущий баланс аккаунта лицензий
     * @param token_ Ключ доступа, полученный при авторизации
     */
    balanceLicGet(params: {  token_: string; }) {
        return DefaultApiFp.balanceLicGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Информация по дебету аккаунта
     * Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения
     * @param token_ Ключ доступа, полученный при авторизации
     */
    billingDebtGet(params: {  token_: string; }) {
        return DefaultApiFp.billingDebtGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Информация об аккаунте
     * Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.
     * @param token_ Ключ доступа, полученный при авторизации
     */
    billingInfoGet(params: {  token_: string; }) {
        return DefaultApiFp.billingInfoGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Получить ограничения аккаунта
     * @param token_ Ключ доступа, полученный при авторизации
     */
    billingLimitsGet(params: {  token_: string; }) {
        return DefaultApiFp.billingLimitsGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Информация по продлению доменов
     * @param token_ Ключ доступа, полученный при авторизации
     */
    dnsProlongListGet(params: {  token_: string; }) {
        return DefaultApiFp.dnsProlongListGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Создание почтового ящика
     * @param token_ Ключ доступа, полученный при авторизации
     * @param addEmail Адрес почтового ящика, который необходимо создать
     */
    emailAddGet(params: {  token_: string; addEmail: string; }) {
        return DefaultApiFp.emailAddGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Удаление псевдонимов почтовых ящиков
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ Адрес почтового ящика, подлежащего удалению
     */
    emailAliasDeleteGet(params: {  token_: string; key_: string; }) {
        return DefaultApiFp.emailAliasDeleteGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Получить список псевдонимов почтовых ящиков
     * @param token_ Ключ доступа, полученный при авторизации
     */
    emailAliasListGet(params: {  token_: string; }) {
        return DefaultApiFp.emailAliasListGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Удаление почтового ящика
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ Адрес почтового ящика, подлежащего удалению
     */
    emailDeleteGet(params: {  token_: string; key_: string; }) {
        return DefaultApiFp.emailDeleteGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Получить список почтовых ящиков
     * @param token_ Ключ доступа, полученный при авторизации
     */
    emailListGet(params: {  token_: string; }) {
        return DefaultApiFp.emailListGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Идентификатор последнего уведомления в аудите
     * @param token_ Ключ доступа, полученный при авторизации
     */
    updatesLastGet(params: {  token_: string; }) {
        return DefaultApiFp.updatesLastGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Список записей аудита
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID первой записи для показа или 0 для показа всех записей
     */
    updatesListGet(params: {  token_: string; key_: number; }) {
        return DefaultApiFp.updatesListGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Удаление сайта
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID сайта, полученный из /website/list
     */
    websiteDeleteGet(params: {  token_: string; key_: string; }) {
        return DefaultApiFp.websiteDeleteGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Список сайтов аккаунта
     * @param token_ Ключ доступа, полученный при авторизации
     */
    websiteListGet(params: {  token_: string; }) {
        return DefaultApiFp.websiteListGet(params)(this.fetch, this.basePath);
    }
}


/**
 * AuthAPIApi - fetch parameter creator
 */
export const AuthAPIApiFetchParamCreactor = {
    /** 
     * Получить ключ доступа
     * Возвращает ключ доступа, с которым в дальнейшем будут осуществляться всё взаимодействие с API  (параметр &#39;token&#39;). Для вычисления значения параметра &#39;response&#39; необходимо получить представленную в hex MD5-сумму от  объединения строк пароля пользователя, полученной соли и символа переноса строки. Псевдокод операции:  hex(md5(password&amp;nbsp;+&amp;nbsp;salt&amp;nbsp;+&amp;nbsp;&#39;\\n&#39;))
     * @param login Имя пользователя
     * @param salt Соль (см. /auth/start)
     * @param response Вычисленный хэш
     */
    authLoginPost(params: {  login: string; salt: string; response: string; }): FetchArgs {
        // verify required parameter "login" is set
        if (params["login"] == null) {
            throw new Error("Missing required parameter login when calling authLoginPost");
        }
        // verify required parameter "salt" is set
        if (params["salt"] == null) {
            throw new Error("Missing required parameter salt when calling authLoginPost");
        }
        // verify required parameter "response" is set
        if (params["response"] == null) {
            throw new Error("Missing required parameter response when calling authLoginPost");
        }
        const baseUrl = `/auth/login`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "login": params.login,
            "salt": params.salt,
            "response": params.response,
        });
        let fetchOptions: RequestInit = { method: "POST" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Получить соль
     * Возвращает соль для авторизации. Это первый этап идентификации пользователя. Затем соль используется  во втором, окончательном этапе авторизации, в запросе /auth/login. Запрос не требует дополнительных параметров.
     * @param login Имя пользователя
     */
    authStartGet(params: {  login: string; }): FetchArgs {
        // verify required parameter "login" is set
        if (params["login"] == null) {
            throw new Error("Missing required parameter login when calling authStartGet");
        }
        const baseUrl = `/auth/start`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "login": params.login,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
}

/**
 * AuthAPIApi - functional programming interface
 */
export const AuthAPIApiFp = {
    /** 
     * Получить ключ доступа
     * Возвращает ключ доступа, с которым в дальнейшем будут осуществляться всё взаимодействие с API  (параметр &#39;token&#39;). Для вычисления значения параметра &#39;response&#39; необходимо получить представленную в hex MD5-сумму от  объединения строк пароля пользователя, полученной соли и символа переноса строки. Псевдокод операции:  hex(md5(password&amp;nbsp;+&amp;nbsp;salt&amp;nbsp;+&amp;nbsp;&#39;\\n&#39;))
     * @param login Имя пользователя
     * @param salt Соль (см. /auth/start)
     * @param response Вычисленный хэш
     */
    authLoginPost(params: { login: string; salt: string; response: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<string> {
        const fetchArgs = AuthAPIApiFetchParamCreactor.authLoginPost(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Получить соль
     * Возвращает соль для авторизации. Это первый этап идентификации пользователя. Затем соль используется  во втором, окончательном этапе авторизации, в запросе /auth/login. Запрос не требует дополнительных параметров.
     * @param login Имя пользователя
     */
    authStartGet(params: { login: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<string> {
        const fetchArgs = AuthAPIApiFetchParamCreactor.authStartGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
};

/**
 * AuthAPIApi - object-oriented interface
 */
export class AuthAPIApi extends BaseAPI {
    /** 
     * Получить ключ доступа
     * Возвращает ключ доступа, с которым в дальнейшем будут осуществляться всё взаимодействие с API  (параметр &#39;token&#39;). Для вычисления значения параметра &#39;response&#39; необходимо получить представленную в hex MD5-сумму от  объединения строк пароля пользователя, полученной соли и символа переноса строки. Псевдокод операции:  hex(md5(password&amp;nbsp;+&amp;nbsp;salt&amp;nbsp;+&amp;nbsp;&#39;\\n&#39;))
     * @param login Имя пользователя
     * @param salt Соль (см. /auth/start)
     * @param response Вычисленный хэш
     */
    authLoginPost(params: {  login: string; salt: string; response: string; }) {
        return AuthAPIApiFp.authLoginPost(params)(this.fetch, this.basePath);
    }
    /** 
     * Получить соль
     * Возвращает соль для авторизации. Это первый этап идентификации пользователя. Затем соль используется  во втором, окончательном этапе авторизации, в запросе /auth/login. Запрос не требует дополнительных параметров.
     * @param login Имя пользователя
     */
    authStartGet(params: {  login: string; }) {
        return AuthAPIApiFp.authStartGet(params)(this.fetch, this.basePath);
    }
}


/**
 * DNSApi - fetch parameter creator
 */
export const DNSApiFetchParamCreactor = {
    /** 
     * Создание записи домена
     * @param token_ Ключ доступа, полученный при авторизации
     * @param addDnsZone зона, которую необходимо создать
     * @param addDnsRecord 
     * @param iisSiteForDns ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку
     * @param bindOnly 
     */
    dnsAddGet(params: {  token_: string; addDnsZone: string; addDnsRecord?: string; iisSiteForDns?: string; bindOnly?: boolean; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling dnsAddGet");
        }
        // verify required parameter "addDnsZone" is set
        if (params["addDnsZone"] == null) {
            throw new Error("Missing required parameter addDnsZone when calling dnsAddGet");
        }
        const baseUrl = `/dns/add`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
            "add_dns_zone": params.addDnsZone,
            "add_dns_record": params.addDnsRecord,
            "iis_site_for_dns": params.iisSiteForDns,
            "bind_only": params.bindOnly,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Привязка одного домена к другому
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID домена из списка /dns/list
     * @param bindTo домен, к которому необходимо сделать привязку
     */
    dnsBindGet(params: {  token_: string; key_: number; bindTo?: string; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling dnsBindGet");
        }
        // verify required parameter "key_" is set
        if (params["key_"] == null) {
            throw new Error("Missing required parameter key_ when calling dnsBindGet");
        }
        const baseUrl = `/dns/bind`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
            "_key_": params.key_,
            "bind_to": params.bindTo,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Получить список доменных имён
     * @param token_ Ключ доступа, полученный при авторизации
     */
    dnsListGet(params: {  token_: string; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling dnsListGet");
        }
        const baseUrl = `/dns/list`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Информация по продлению доменов
     * @param token_ Ключ доступа, полученный при авторизации
     */
    dnsProlongListGet(params: {  token_: string; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling dnsProlongListGet");
        }
        const baseUrl = `/dns/prolong/list`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Редактирование \&quot;сырой\&quot; зоны
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID домена из /dns/list
     * @param sDel Значение &#39;1&#39; сообщает, что запись необходимо удалить
     * @param sAdd Значение &#39;1&#39; сообщает, что запись необходимо создать
     * @param dnsType Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV
     * @param dnsName Имя записи, либо &#39;@&#39; для корневой
     * @param dnsValue Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)
     */
    dnsRawGet(params: {  token_: string; key_: number; sDel: number; sAdd: number; dnsType: string; dnsName: string; dnsValue: string; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling dnsRawGet");
        }
        // verify required parameter "key_" is set
        if (params["key_"] == null) {
            throw new Error("Missing required parameter key_ when calling dnsRawGet");
        }
        // verify required parameter "sDel" is set
        if (params["sDel"] == null) {
            throw new Error("Missing required parameter sDel when calling dnsRawGet");
        }
        // verify required parameter "sAdd" is set
        if (params["sAdd"] == null) {
            throw new Error("Missing required parameter sAdd when calling dnsRawGet");
        }
        // verify required parameter "dnsType" is set
        if (params["dnsType"] == null) {
            throw new Error("Missing required parameter dnsType when calling dnsRawGet");
        }
        // verify required parameter "dnsName" is set
        if (params["dnsName"] == null) {
            throw new Error("Missing required parameter dnsName when calling dnsRawGet");
        }
        // verify required parameter "dnsValue" is set
        if (params["dnsValue"] == null) {
            throw new Error("Missing required parameter dnsValue when calling dnsRawGet");
        }
        const baseUrl = `/dns/raw`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
            "_key_": params.key_,
            "s_del": params.sDel,
            "s_add": params.sAdd,
            "dns_type": params.dnsType,
            "dns_name": params.dnsName,
            "dns_value": params.dnsValue,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Редактировать DNS-зону
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID домена из /dns/list
     * @param managedMx Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить
     * @param updManagedMx Значение &#39;1&#39; подтверждает операцию
     */
    dnsRawManagedmxGet(params: {  token_: string; key_: number; managedMx: number; updManagedMx: number; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling dnsRawManagedmxGet");
        }
        // verify required parameter "key_" is set
        if (params["key_"] == null) {
            throw new Error("Missing required parameter key_ when calling dnsRawManagedmxGet");
        }
        // verify required parameter "managedMx" is set
        if (params["managedMx"] == null) {
            throw new Error("Missing required parameter managedMx when calling dnsRawManagedmxGet");
        }
        // verify required parameter "updManagedMx" is set
        if (params["updManagedMx"] == null) {
            throw new Error("Missing required parameter updManagedMx when calling dnsRawManagedmxGet");
        }
        const baseUrl = `/dns/raw/managedmx`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
            "_key_": params.key_,
            "managed_mx": params.managedMx,
            "upd_managed_mx": params.updManagedMx,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
}

/**
 * DNSApi - functional programming interface
 */
export const DNSApiFp = {
    /** 
     * Создание записи домена
     * @param token_ Ключ доступа, полученный при авторизации
     * @param addDnsZone зона, которую необходимо создать
     * @param addDnsRecord 
     * @param iisSiteForDns ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку
     * @param bindOnly 
     */
    dnsAddGet(params: { token_: string; addDnsZone: string; addDnsRecord?: string; iisSiteForDns?: string; bindOnly?: boolean;  }): (fetch: FetchAPI, basePath?: string) => Promise<string> {
        const fetchArgs = DNSApiFetchParamCreactor.dnsAddGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Привязка одного домена к другому
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID домена из списка /dns/list
     * @param bindTo домен, к которому необходимо сделать привязку
     */
    dnsBindGet(params: { token_: string; key_: number; bindTo?: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<string> {
        const fetchArgs = DNSApiFetchParamCreactor.dnsBindGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Получить список доменных имён
     * @param token_ Ключ доступа, полученный при авторизации
     */
    dnsListGet(params: { token_: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<Array<InlineResponse2003>> {
        const fetchArgs = DNSApiFetchParamCreactor.dnsListGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Информация по продлению доменов
     * @param token_ Ключ доступа, полученный при авторизации
     */
    dnsProlongListGet(params: { token_: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<Array<InlineResponse2004>> {
        const fetchArgs = DNSApiFetchParamCreactor.dnsProlongListGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Редактирование \&quot;сырой\&quot; зоны
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID домена из /dns/list
     * @param sDel Значение &#39;1&#39; сообщает, что запись необходимо удалить
     * @param sAdd Значение &#39;1&#39; сообщает, что запись необходимо создать
     * @param dnsType Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV
     * @param dnsName Имя записи, либо &#39;@&#39; для корневой
     * @param dnsValue Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)
     */
    dnsRawGet(params: { token_: string; key_: number; sDel: number; sAdd: number; dnsType: string; dnsName: string; dnsValue: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<string> {
        const fetchArgs = DNSApiFetchParamCreactor.dnsRawGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Редактировать DNS-зону
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID домена из /dns/list
     * @param managedMx Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить
     * @param updManagedMx Значение &#39;1&#39; подтверждает операцию
     */
    dnsRawManagedmxGet(params: { token_: string; key_: number; managedMx: number; updManagedMx: number;  }): (fetch: FetchAPI, basePath?: string) => Promise<string> {
        const fetchArgs = DNSApiFetchParamCreactor.dnsRawManagedmxGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
};

/**
 * DNSApi - object-oriented interface
 */
export class DNSApi extends BaseAPI {
    /** 
     * Создание записи домена
     * @param token_ Ключ доступа, полученный при авторизации
     * @param addDnsZone зона, которую необходимо создать
     * @param addDnsRecord 
     * @param iisSiteForDns ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку
     * @param bindOnly 
     */
    dnsAddGet(params: {  token_: string; addDnsZone: string; addDnsRecord?: string; iisSiteForDns?: string; bindOnly?: boolean; }) {
        return DNSApiFp.dnsAddGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Привязка одного домена к другому
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID домена из списка /dns/list
     * @param bindTo домен, к которому необходимо сделать привязку
     */
    dnsBindGet(params: {  token_: string; key_: number; bindTo?: string; }) {
        return DNSApiFp.dnsBindGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Получить список доменных имён
     * @param token_ Ключ доступа, полученный при авторизации
     */
    dnsListGet(params: {  token_: string; }) {
        return DNSApiFp.dnsListGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Информация по продлению доменов
     * @param token_ Ключ доступа, полученный при авторизации
     */
    dnsProlongListGet(params: {  token_: string; }) {
        return DNSApiFp.dnsProlongListGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Редактирование \&quot;сырой\&quot; зоны
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID домена из /dns/list
     * @param sDel Значение &#39;1&#39; сообщает, что запись необходимо удалить
     * @param sAdd Значение &#39;1&#39; сообщает, что запись необходимо создать
     * @param dnsType Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV
     * @param dnsName Имя записи, либо &#39;@&#39; для корневой
     * @param dnsValue Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)
     */
    dnsRawGet(params: {  token_: string; key_: number; sDel: number; sAdd: number; dnsType: string; dnsName: string; dnsValue: string; }) {
        return DNSApiFp.dnsRawGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Редактировать DNS-зону
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID домена из /dns/list
     * @param managedMx Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить
     * @param updManagedMx Значение &#39;1&#39; подтверждает операцию
     */
    dnsRawManagedmxGet(params: {  token_: string; key_: number; managedMx: number; updManagedMx: number; }) {
        return DNSApiFp.dnsRawManagedmxGet(params)(this.fetch, this.basePath);
    }
}


/**
 * HostingftpAPIApi - fetch parameter creator
 */
export const HostingftpAPIApiFetchParamCreactor = {
    /** 
     * Получить список зарегистрированных аккаунтов FTP
     * @param token_ Ключ доступа, полученный при авторизации
     */
    ftpListGet(params: {  token_: string; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling ftpListGet");
        }
        const baseUrl = `/ftp/list`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
}

/**
 * HostingftpAPIApi - functional programming interface
 */
export const HostingftpAPIApiFp = {
    /** 
     * Получить список зарегистрированных аккаунтов FTP
     * @param token_ Ключ доступа, полученный при авторизации
     */
    ftpListGet(params: { token_: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<Array<InlineResponse2007>> {
        const fetchArgs = HostingftpAPIApiFetchParamCreactor.ftpListGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
};

/**
 * HostingftpAPIApi - object-oriented interface
 */
export class HostingftpAPIApi extends BaseAPI {
    /** 
     * Получить список зарегистрированных аккаунтов FTP
     * @param token_ Ключ доступа, полученный при авторизации
     */
    ftpListGet(params: {  token_: string; }) {
        return HostingftpAPIApiFp.ftpListGet(params)(this.fetch, this.basePath);
    }
}


/**
 * HostingiisAPIApi - fetch parameter creator
 */
export const HostingiisAPIApiFetchParamCreactor = {
    /** 
     * Список сайтов IIS
     * @param token_ Ключ доступа, полученный при авторизации
     */
    iisListGet(params: {  token_: string; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling iisListGet");
        }
        const baseUrl = `/iis/list`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
}

/**
 * HostingiisAPIApi - functional programming interface
 */
export const HostingiisAPIApiFp = {
    /** 
     * Список сайтов IIS
     * @param token_ Ключ доступа, полученный при авторизации
     */
    iisListGet(params: { token_: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<Array<InlineResponse2008>> {
        const fetchArgs = HostingiisAPIApiFetchParamCreactor.iisListGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
};

/**
 * HostingiisAPIApi - object-oriented interface
 */
export class HostingiisAPIApi extends BaseAPI {
    /** 
     * Список сайтов IIS
     * @param token_ Ключ доступа, полученный при авторизации
     */
    iisListGet(params: {  token_: string; }) {
        return HostingiisAPIApiFp.iisListGet(params)(this.fetch, this.basePath);
    }
}


/**
 * MicrosoftSQLServerApi - fetch parameter creator
 */
export const MicrosoftSQLServerApiFetchParamCreactor = {
    /** 
     * Получить список аккаунтов в MSSQL
     * @param token_ Ключ доступа, полученный при авторизации
     */
    mssqlListGet(params: {  token_: string; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling mssqlListGet");
        }
        const baseUrl = `/mssql/list`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
}

/**
 * MicrosoftSQLServerApi - functional programming interface
 */
export const MicrosoftSQLServerApiFp = {
    /** 
     * Получить список аккаунтов в MSSQL
     * @param token_ Ключ доступа, полученный при авторизации
     */
    mssqlListGet(params: { token_: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<Array<InlineResponse2009>> {
        const fetchArgs = MicrosoftSQLServerApiFetchParamCreactor.mssqlListGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
};

/**
 * MicrosoftSQLServerApi - object-oriented interface
 */
export class MicrosoftSQLServerApi extends BaseAPI {
    /** 
     * Получить список аккаунтов в MSSQL
     * @param token_ Ключ доступа, полученный при авторизации
     */
    mssqlListGet(params: {  token_: string; }) {
        return MicrosoftSQLServerApiFp.mssqlListGet(params)(this.fetch, this.basePath);
    }
}


/**
 * MySQLPostgresApi - fetch parameter creator
 */
export const MySQLPostgresApiFetchParamCreactor = {
    /** 
     * Список аккаунтов в базах данных UNIX
     * Возвращает список зарегистрированных аккаунтов в базах данных MySQL и Postgres. Для вычисления имени домена необходимо объединить имя базы данных,   идентификатор сервера и суффикс (поле url_suffix). Например, если ID сервера равен 123 (значит это MySQL — см. описание поля &#39;server&#39; в ответе), а суффикс равен &#39;1gb.ru&#39;, то домен   для доступа будет равен &#39;mysql123.1gb.ru&#39;.
     * @param token_ Ключ доступа, полученный при авторизации
     */
    databaseListGet(params: {  token_: string; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling databaseListGet");
        }
        const baseUrl = `/database/list`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
}

/**
 * MySQLPostgresApi - functional programming interface
 */
export const MySQLPostgresApiFp = {
    /** 
     * Список аккаунтов в базах данных UNIX
     * Возвращает список зарегистрированных аккаунтов в базах данных MySQL и Postgres. Для вычисления имени домена необходимо объединить имя базы данных,   идентификатор сервера и суффикс (поле url_suffix). Например, если ID сервера равен 123 (значит это MySQL — см. описание поля &#39;server&#39; в ответе), а суффикс равен &#39;1gb.ru&#39;, то домен   для доступа будет равен &#39;mysql123.1gb.ru&#39;.
     * @param token_ Ключ доступа, полученный при авторизации
     */
    databaseListGet(params: { token_: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<Array<InlineResponse2002>> {
        const fetchArgs = MySQLPostgresApiFetchParamCreactor.databaseListGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
};

/**
 * MySQLPostgresApi - object-oriented interface
 */
export class MySQLPostgresApi extends BaseAPI {
    /** 
     * Список аккаунтов в базах данных UNIX
     * Возвращает список зарегистрированных аккаунтов в базах данных MySQL и Postgres. Для вычисления имени домена необходимо объединить имя базы данных,   идентификатор сервера и суффикс (поле url_suffix). Например, если ID сервера равен 123 (значит это MySQL — см. описание поля &#39;server&#39; в ответе), а суффикс равен &#39;1gb.ru&#39;, то домен   для доступа будет равен &#39;mysql123.1gb.ru&#39;.
     * @param token_ Ключ доступа, полученный при авторизации
     */
    databaseListGet(params: {  token_: string; }) {
        return MySQLPostgresApiFp.databaseListGet(params)(this.fetch, this.basePath);
    }
}


/**
 * VDSHyperVOpenVZApi - fetch parameter creator
 */
export const VDSHyperVOpenVZApiFetchParamCreactor = {
    /** 
     * Изменение параметров VDS
     * Изменение параметров уже существующего VDS
     * @param token_ Ключ доступа, полученный при авторизации
     * @param type Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39;
     * @param crHvmem Количество доступной памяти в мегабайтах. По умолчанию 2048
     * @param crHvdsk Количество доступных гигабайт диска. По умолчанию 30
     * @param crHvcpu Количество ядер CPU. По умолчанию 2
     * @param template Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list
     * @param forceMemo 
     * @param hv1gbPanelVersion 
     * @param panelInstall Необходимо ли установить панель 1Gb на VDS
     * @param crSsd1 Создать всю систему на SSD
     * @param crHvAllSystem Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными)
     */
    vdsCreateGet(params: {  token_: string; type?: string; crHvmem?: number; crHvdsk?: number; crHvcpu?: number; template?: string; forceMemo?: string; hv1gbPanelVersion?: string; panelInstall?: boolean; crSsd1?: boolean; crHvAllSystem?: boolean; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling vdsCreateGet");
        }
        const baseUrl = `/vds/create`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
            "type": params.type,
            "cr_hvmem": params.crHvmem,
            "cr_hvdsk": params.crHvdsk,
            "cr_hvcpu": params.crHvcpu,
            "template": params.template,
            "force_memo": params.forceMemo,
            "hv_1gb_panel_version": params.hv1gbPanelVersion,
            "panel_install": params.panelInstall,
            "cr_ssd1": params.crSsd1,
            "cr_hv_all_system": params.crHvAllSystem,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Удаление VDS
     * Предоставляет функционал для удаления VDS
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера, полученный из /vds/list
     * @param forceCritical Если true, VDS будет удален срочно
     */
    vdsDeleteGet(params: {  token_: string; key_: number; forceCritical?: boolean; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling vdsDeleteGet");
        }
        // verify required parameter "key_" is set
        if (params["key_"] == null) {
            throw new Error("Missing required parameter key_ when calling vdsDeleteGet");
        }
        const baseUrl = `/vds/delete`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
            "_key_": params.key_,
            "force_critical": params.forceCritical,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Добавление IP на VDS
     * Этот вызов позволяет добавить ещё один IP адрес на указанный VDS
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера, полученный из /vds/list
     */
    vdsIpAddGet(params: {  token_: string; key_: number; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling vdsIpAddGet");
        }
        // verify required parameter "key_" is set
        if (params["key_"] == null) {
            throw new Error("Missing required parameter key_ when calling vdsIpAddGet");
        }
        const baseUrl = `/vds/ip/add`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
            "_key_": params.key_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Удаление IP с VDS
     * Этот вызов позволяет отвязать IP адрес от VDS
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера, полученный из /vds/list
     * @param delIp IP адрес, который необходимо удалить
     */
    vdsIpDeleteGet(params: {  token_: string; key_: number; delIp: string; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling vdsIpDeleteGet");
        }
        // verify required parameter "key_" is set
        if (params["key_"] == null) {
            throw new Error("Missing required parameter key_ when calling vdsIpDeleteGet");
        }
        // verify required parameter "delIp" is set
        if (params["delIp"] == null) {
            throw new Error("Missing required parameter delIp when calling vdsIpDeleteGet");
        }
        const baseUrl = `/vds/ip/delete`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
            "_key_": params.key_,
            "del_ip": params.delIp,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Список IP-адресов виртуальных серверов
     * Список IP-адресов виртуальных серверов
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера, полученный из /vds/list
     */
    vdsIpListGet(params: {  token_: string; key_?: number; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling vdsIpListGet");
        }
        const baseUrl = `/vds/ip/list`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
            "_key_": params.key_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Список виртуальных серверов
     * Позволяет получить список виртуальных серверов
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS
     */
    vdsListGet(params: {  token_: string; key_?: number; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling vdsListGet");
        }
        const baseUrl = `/vds/list`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
            "_key_": params.key_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Перезагрузка VDS
     * Предоставляет функционал для перезагрузки VDS
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера, полученный из /vds/list
     */
    vdsRebootGet(params: {  token_: string; key_: number; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling vdsRebootGet");
        }
        // verify required parameter "key_" is set
        if (params["key_"] == null) {
            throw new Error("Missing required parameter key_ when calling vdsRebootGet");
        }
        const baseUrl = `/vds/reboot`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
            "_key_": params.key_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Список шаблонов виртуальных серверов
     * Позволяет получить список шаблонов виртуальных серверов
     * @param token_ Ключ доступа, полученный при авторизации
     */
    vdsTemplatesListGet(params: {  token_: string; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling vdsTemplatesListGet");
        }
        const baseUrl = `/vds/templates-list`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
    /** 
     * Создание VDS
     * Создание новых VDS с произвольными характеристиками
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера, полученный из /vds/list
     * @param crHvmem Количество доступной памяти в мегабайтах. По умолчанию 2048
     * @param crHvdsk Количество доступных гигабайт диска. По умолчанию 30
     * @param crHvcpu Количество ядер CPU. По умолчанию 2
     */
    vdsUpdateGet(params: {  token_: string; key_: number; crHvmem?: number; crHvdsk?: number; crHvcpu?: number; }): FetchArgs {
        // verify required parameter "token_" is set
        if (params["token_"] == null) {
            throw new Error("Missing required parameter token_ when calling vdsUpdateGet");
        }
        // verify required parameter "key_" is set
        if (params["key_"] == null) {
            throw new Error("Missing required parameter key_ when calling vdsUpdateGet");
        }
        const baseUrl = `/vds/update`;
        let urlObj = url.parse(baseUrl, true);
        urlObj.query = assign({}, urlObj.query, { 
            "_token_": params.token_,
            "_key_": params.key_,
            "cr_hvmem": params.crHvmem,
            "cr_hvdsk": params.crHvdsk,
            "cr_hvcpu": params.crHvcpu,
        });
        let fetchOptions: RequestInit = { method: "GET" };

        let contentTypeHeader: Dictionary<string>;
        if (contentTypeHeader) {
            fetchOptions.headers = contentTypeHeader;
        }
        return {
            url: url.format(urlObj),
            options: fetchOptions,
        };
    },
}

/**
 * VDSHyperVOpenVZApi - functional programming interface
 */
export const VDSHyperVOpenVZApiFp = {
    /** 
     * Изменение параметров VDS
     * Изменение параметров уже существующего VDS
     * @param token_ Ключ доступа, полученный при авторизации
     * @param type Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39;
     * @param crHvmem Количество доступной памяти в мегабайтах. По умолчанию 2048
     * @param crHvdsk Количество доступных гигабайт диска. По умолчанию 30
     * @param crHvcpu Количество ядер CPU. По умолчанию 2
     * @param template Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list
     * @param forceMemo 
     * @param hv1gbPanelVersion 
     * @param panelInstall Необходимо ли установить панель 1Gb на VDS
     * @param crSsd1 Создать всю систему на SSD
     * @param crHvAllSystem Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными)
     */
    vdsCreateGet(params: { token_: string; type?: string; crHvmem?: number; crHvdsk?: number; crHvcpu?: number; template?: string; forceMemo?: string; hv1gbPanelVersion?: string; panelInstall?: boolean; crSsd1?: boolean; crHvAllSystem?: boolean;  }): (fetch: FetchAPI, basePath?: string) => Promise<string> {
        const fetchArgs = VDSHyperVOpenVZApiFetchParamCreactor.vdsCreateGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Удаление VDS
     * Предоставляет функционал для удаления VDS
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера, полученный из /vds/list
     * @param forceCritical Если true, VDS будет удален срочно
     */
    vdsDeleteGet(params: { token_: string; key_: number; forceCritical?: boolean;  }): (fetch: FetchAPI, basePath?: string) => Promise<string> {
        const fetchArgs = VDSHyperVOpenVZApiFetchParamCreactor.vdsDeleteGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Добавление IP на VDS
     * Этот вызов позволяет добавить ещё один IP адрес на указанный VDS
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера, полученный из /vds/list
     */
    vdsIpAddGet(params: { token_: string; key_: number;  }): (fetch: FetchAPI, basePath?: string) => Promise<string> {
        const fetchArgs = VDSHyperVOpenVZApiFetchParamCreactor.vdsIpAddGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Удаление IP с VDS
     * Этот вызов позволяет отвязать IP адрес от VDS
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера, полученный из /vds/list
     * @param delIp IP адрес, который необходимо удалить
     */
    vdsIpDeleteGet(params: { token_: string; key_: number; delIp: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<string> {
        const fetchArgs = VDSHyperVOpenVZApiFetchParamCreactor.vdsIpDeleteGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Список IP-адресов виртуальных серверов
     * Список IP-адресов виртуальных серверов
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера, полученный из /vds/list
     */
    vdsIpListGet(params: { token_: string; key_?: number;  }): (fetch: FetchAPI, basePath?: string) => Promise<Array<InlineResponse20011>> {
        const fetchArgs = VDSHyperVOpenVZApiFetchParamCreactor.vdsIpListGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Список виртуальных серверов
     * Позволяет получить список виртуальных серверов
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS
     */
    vdsListGet(params: { token_: string; key_?: number;  }): (fetch: FetchAPI, basePath?: string) => Promise<Array<InlineResponse20012>> {
        const fetchArgs = VDSHyperVOpenVZApiFetchParamCreactor.vdsListGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Перезагрузка VDS
     * Предоставляет функционал для перезагрузки VDS
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера, полученный из /vds/list
     */
    vdsRebootGet(params: { token_: string; key_: number;  }): (fetch: FetchAPI, basePath?: string) => Promise<string> {
        const fetchArgs = VDSHyperVOpenVZApiFetchParamCreactor.vdsRebootGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Список шаблонов виртуальных серверов
     * Позволяет получить список шаблонов виртуальных серверов
     * @param token_ Ключ доступа, полученный при авторизации
     */
    vdsTemplatesListGet(params: { token_: string;  }): (fetch: FetchAPI, basePath?: string) => Promise<Array<InlineResponse20013>> {
        const fetchArgs = VDSHyperVOpenVZApiFetchParamCreactor.vdsTemplatesListGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
    /** 
     * Создание VDS
     * Создание новых VDS с произвольными характеристиками
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера, полученный из /vds/list
     * @param crHvmem Количество доступной памяти в мегабайтах. По умолчанию 2048
     * @param crHvdsk Количество доступных гигабайт диска. По умолчанию 30
     * @param crHvcpu Количество ядер CPU. По умолчанию 2
     */
    vdsUpdateGet(params: { token_: string; key_: number; crHvmem?: number; crHvdsk?: number; crHvcpu?: number;  }): (fetch: FetchAPI, basePath?: string) => Promise<string> {
        const fetchArgs = VDSHyperVOpenVZApiFetchParamCreactor.vdsUpdateGet(params);
        return (fetch: FetchAPI = isomorphicFetch, basePath: string = BASE_PATH) => {
            return fetch(basePath + fetchArgs.url, fetchArgs.options).then((response) => {
                if (response.status >= 200 && response.status < 300) {
                    return response.json();
                } else {
                    throw response;
                }
            });
        };
    },
};

/**
 * VDSHyperVOpenVZApi - object-oriented interface
 */
export class VDSHyperVOpenVZApi extends BaseAPI {
    /** 
     * Изменение параметров VDS
     * Изменение параметров уже существующего VDS
     * @param token_ Ключ доступа, полученный при авторизации
     * @param type Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39;
     * @param crHvmem Количество доступной памяти в мегабайтах. По умолчанию 2048
     * @param crHvdsk Количество доступных гигабайт диска. По умолчанию 30
     * @param crHvcpu Количество ядер CPU. По умолчанию 2
     * @param template Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list
     * @param forceMemo 
     * @param hv1gbPanelVersion 
     * @param panelInstall Необходимо ли установить панель 1Gb на VDS
     * @param crSsd1 Создать всю систему на SSD
     * @param crHvAllSystem Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными)
     */
    vdsCreateGet(params: {  token_: string; type?: string; crHvmem?: number; crHvdsk?: number; crHvcpu?: number; template?: string; forceMemo?: string; hv1gbPanelVersion?: string; panelInstall?: boolean; crSsd1?: boolean; crHvAllSystem?: boolean; }) {
        return VDSHyperVOpenVZApiFp.vdsCreateGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Удаление VDS
     * Предоставляет функционал для удаления VDS
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера, полученный из /vds/list
     * @param forceCritical Если true, VDS будет удален срочно
     */
    vdsDeleteGet(params: {  token_: string; key_: number; forceCritical?: boolean; }) {
        return VDSHyperVOpenVZApiFp.vdsDeleteGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Добавление IP на VDS
     * Этот вызов позволяет добавить ещё один IP адрес на указанный VDS
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера, полученный из /vds/list
     */
    vdsIpAddGet(params: {  token_: string; key_: number; }) {
        return VDSHyperVOpenVZApiFp.vdsIpAddGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Удаление IP с VDS
     * Этот вызов позволяет отвязать IP адрес от VDS
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера, полученный из /vds/list
     * @param delIp IP адрес, который необходимо удалить
     */
    vdsIpDeleteGet(params: {  token_: string; key_: number; delIp: string; }) {
        return VDSHyperVOpenVZApiFp.vdsIpDeleteGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Список IP-адресов виртуальных серверов
     * Список IP-адресов виртуальных серверов
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера, полученный из /vds/list
     */
    vdsIpListGet(params: {  token_: string; key_?: number; }) {
        return VDSHyperVOpenVZApiFp.vdsIpListGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Список виртуальных серверов
     * Позволяет получить список виртуальных серверов
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS
     */
    vdsListGet(params: {  token_: string; key_?: number; }) {
        return VDSHyperVOpenVZApiFp.vdsListGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Перезагрузка VDS
     * Предоставляет функционал для перезагрузки VDS
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера, полученный из /vds/list
     */
    vdsRebootGet(params: {  token_: string; key_: number; }) {
        return VDSHyperVOpenVZApiFp.vdsRebootGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Список шаблонов виртуальных серверов
     * Позволяет получить список шаблонов виртуальных серверов
     * @param token_ Ключ доступа, полученный при авторизации
     */
    vdsTemplatesListGet(params: {  token_: string; }) {
        return VDSHyperVOpenVZApiFp.vdsTemplatesListGet(params)(this.fetch, this.basePath);
    }
    /** 
     * Создание VDS
     * Создание новых VDS с произвольными характеристиками
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID виртуального сервера, полученный из /vds/list
     * @param crHvmem Количество доступной памяти в мегабайтах. По умолчанию 2048
     * @param crHvdsk Количество доступных гигабайт диска. По умолчанию 30
     * @param crHvcpu Количество ядер CPU. По умолчанию 2
     */
    vdsUpdateGet(params: {  token_: string; key_: number; crHvmem?: number; crHvdsk?: number; crHvcpu?: number; }) {
        return VDSHyperVOpenVZApiFp.vdsUpdateGet(params)(this.fetch, this.basePath);
    }
}

